#!/usr/bin/perl

$adfile = 'ads.csv';

# No modification is necessary after this line ------------------

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
if (length($buffer) < 5) {
$buffer = $ENV{QUERY_STRING};
}

@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
 {
($name, $value) = split(/=/, $pair);
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$value =~ s/[\;\|\\ ]/ /ig;
push(@values,$value); push(@names,$name);
$FORM{$name} = $value;
}

# Get Variables.

$adcolor = $FORM{'clr'};
$keyword1 = $FORM{'k1'};
$keyword2 = $FORM{'k2'};
$keyword3 = $FORM{'k3'};
$adtype = $FORM{'t'};

$counter = 0;
$delimiter = '\|';

## Print Statement
print "Content-type: text/html\n\n";

if ($adtype eq "h") {
	$template = 'template-1.js';
}
else
{
    $template = 'template-2.js';
}

open(ADS, "<$adfile") || die "$adfile could not be opened";
# Place each line into an array
my @ad_list = <ADS>;
close(ADS);

@myads = ();

#-------------------
$counter = 0;
foreach(@ad_list)
{
if ($ad_list[$counter] =~ m/$keyword1/i)
	{
push(@myads, $ad_list[$counter]);
    }
$counter = $counter + 1;
}
#-------------------
$counter = 0;
foreach(@ad_list)
{
if ($ad_list[$counter] =~ m/$keyword2/i)
	{
push(@myads, $ad_list[$counter]);
    }
$counter = $counter + 1;
}
#-------------------
$counter = 0;
foreach(@ad_list)
{
if ($ad_list[$counter] =~ m/$keyword3/i)
	{
push(@myads, $ad_list[$counter]);
    }
$counter = $counter + 1;
}
#-------------------

$counter = 0;

foreach(@myads) 
{
  $counter = $counter + 1;
}

$first_ad = int( rand($counter)) + 1;
$second_ad = int( rand($counter)) + 1;
$third_ad = int( rand($counter)) + 1;

if ($first_ad == $second_ad ) {
  $first_ad = int( rand($counter)) + 1;
}

if ($first_ad == $third_ad ) {
  $third_ad = int( rand($counter)) + 1;
}

if ($second_ad == $third_ad ) {
  $second_ad = int( rand($counter)) + 1;
}


if ($adcolor < 1 || $adcolor > 15 ) {
	$adcolor = int( rand(14)) + 1;
}

if ($adcolor == 1) {
    $border_color = '#000000';
	$bkg_color = '#D2E9FF';
}

if ($adcolor == 2) {
    $border_color = '#000000';
	$bkg_color = '#C7E2E2';
}

if ($adcolor == 3) {
    $border_color = '#000000';
	$bkg_color = '#EBEBD8';
}

if ($adcolor == 4) {
    $border_color = '#000000';
	$bkg_color = '#FFFFCC';
}

if ($adcolor == 5) {
    $border_color = '#000000';
	$bkg_color = '#FFD7EB';
}

if ($adcolor == 6) {
    $border_color = '#000000';
	$bkg_color = '#FFD1BF';
}
if ($adcolor == 7) {
    $border_color = '#000000';
	$bkg_color = '#DFDFDF';
}
if ($adcolor == 8) {
    $border_color = '#000000';
	$bkg_color = '#DDFFFF';
}
if ($adcolor == 9) {
    $border_color = '#000000';
	$bkg_color = '#EBD7FF';
}
if ($adcolor == 10) {
    $border_color = '#000000';
	$bkg_color = '#DFDFFF';
}
if ($adcolor == 11) {
    $border_color = '#000000';
	$bkg_color = '#FFFFFF';
}
if ($adcolor == 12) {
    $border_color = '#000000';
	$bkg_color = '#D7FFD7';
}
if ($adcolor == 13) {
    $border_color = '#000000';
	$bkg_color = '#B3E7FF';
}
if ($adcolor == 14) {
    $border_color = '#000000';
	$bkg_color = '#FFDDBB';
}
if ($adcolor == 15) {
    $border_color = '#000000';
	$bkg_color = '#D9B3B3';
}

# loop through the array of list
$x = 1;
foreach(@myads) 
{
     my ($madtitle,$mdesc,$murl,$xxx) = split($delimiter,$_,4);
	 		 	    
		if ($first_ad eq $x) 
			{
			$mtitle1 = $madtitle;
			$mdesc1 = $mdesc;
			$murl1 = $murl;
			}

        if ($second_ad eq $x) 
			{
			$mtitle2 = $madtitle;
			$mdesc2 = $mdesc;
			$murl2 = $murl;
			}

        if ($third_ad eq $x) 
			{
			$mtitle3 = $madtitle;
			$mdesc3 = $mdesc;
			$murl3 = $murl;
			}

	 $x = $x+1;
}


open( TEMPLATEFILE,$template ) || die "$template could not be opened";
my $thisfile = join( '',<TEMPLATEFILE> );
close( TEMPLATEFILE );

$thisfile =~ s/\$mtitle1/$mtitle1/g;
$thisfile =~ s/\$mdesc1/$mdesc1/g;
$thisfile =~ s/\$murl1/$murl1/g;

$thisfile =~ s/\$mtitle2/$mtitle2/g;
$thisfile =~ s/\$mdesc2/$mdesc2/g;
$thisfile =~ s/\$murl2/$murl2/g;

$thisfile =~ s/\$mtitle3/$mtitle3/g;
$thisfile =~ s/\$mdesc3/$mdesc3/g;
$thisfile =~ s/\$murl3/$murl3/g;

$thisfile =~ s/\$BorderColor/$border_color/g;
$thisfile =~ s/\$BkgndColor/$bkg_color/g;

print $thisfile;

exit;

## The End ----------------------------------------*
